package com.winhc.max.compute.graph.job.holder;

import com.aliyun.odps.graph.Aggregator;
import com.aliyun.odps.graph.WorkerContext;
import com.aliyun.odps.io.BooleanWritable;
import com.aliyun.odps.io.NullWritable;
import com.winhc.max.compute.graph.job.holder.entity.HolderRelationGroupAggValue;

import java.io.IOException;


public class HolderRelationGroupAggregator extends Aggregator<HolderRelationGroupAggValue> {

    private static Integer run_step;

    @Override
    public HolderRelationGroupAggValue createStartupValue(WorkerContext context) throws IOException {
        run_step = context.getConfiguration().getInt("run_step", 1);
        return super.createStartupValue(context);
    }

    @Override
    public HolderRelationGroupAggValue createInitialValue(WorkerContext context) throws IOException {
        return new HolderRelationGroupAggValue();
    }

    @Override
    public void aggregate(HolderRelationGroupAggValue enterpriseGroupAggValue, Object item) throws IOException {
        if (item instanceof NullWritable) {
            enterpriseGroupAggValue.increment();
        } else {
            BooleanWritable tmp = ((BooleanWritable) item);
            enterpriseGroupAggValue.update(tmp.get());
        }
    }

    @Override
    public void merge(HolderRelationGroupAggValue enterpriseGroupAggValue, HolderRelationGroupAggValue partial) throws IOException {
        boolean tmp = partial.getFlag().get();
        enterpriseGroupAggValue.update(tmp);
        enterpriseGroupAggValue.increment(partial.getCount());
    }

    @Override
    public boolean terminate(WorkerContext context, HolderRelationGroupAggValue holderRelationGroupAggValue) throws IOException {
        System.out.println("step: " + context.getSuperstep() + ", iterations node count: " + holderRelationGroupAggValue.getCount() + " ,flag=" + holderRelationGroupAggValue.getFlag().get());
        if (context.getSuperstep() >= run_step) {
            System.out.println("\t pass step " + context.getSuperstep() + "...success");
            return true;
        }
        return !holderRelationGroupAggValue.getFlag().get();
    }
}
