package com.winhc.max.compute.graph.job.holder.entity;

import com.aliyun.odps.io.DoubleWritable;
import com.aliyun.odps.io.IntWritable;
import com.aliyun.odps.io.Writable;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;


public class HolderRelationGroupEdge implements Writable {

    /**
     * 投资比例，小数
     */
    private DoubleWritable investmentProportion;

    /**
     * 股东是个人还是企业
     * 普通企业：1，国家机关：2，个人：3，节点不存在企业：4
     */
    private IntWritable holderType;

    public DoubleWritable getInvestmentProportion() {
        return investmentProportion;
    }

    public IntWritable getHolderType() {
        return holderType;
    }

    public static HolderRelationGroupEdge of(String holderId, Double investmentProportion) {
        HolderRelationGroupEdge holderEdge = new HolderRelationGroupEdge();
        holderEdge.holderType = new IntWritable(holderId.length() == 32 ? 1 : 3);
        holderEdge.investmentProportion = new DoubleWritable(investmentProportion);
        return holderEdge;
    }

    public static HolderRelationGroupEdge of(Integer holderType, Double investmentProportion) {
        HolderRelationGroupEdge holderEdge = new HolderRelationGroupEdge();
        holderEdge.holderType = new IntWritable(holderType);
        holderEdge.investmentProportion = new DoubleWritable(investmentProportion);
        return holderEdge;
    }


    @Override
    public void write(DataOutput out) throws IOException {
        investmentProportion.write(out);
        holderType.write(out);

    }

    @Override
    public void readFields(DataInput in) throws IOException {
        investmentProportion = new DoubleWritable();
        holderType = new IntWritable();

        investmentProportion.readFields(in);
        holderType.readFields(in);
    }
}
