package com.winhc.max.compute.graph.job.holder.entity;

import com.aliyun.odps.io.IntWritable;
import com.aliyun.odps.io.Text;
import com.aliyun.odps.io.Tuple;
import com.aliyun.odps.io.Writable;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import static com.winhc.max.compute.graph.job.holder.HolderRelationGroupVertex.list2Tuple2;


public class HolderRelationGroupVertexValue implements Writable {

    private Text companyName;

//    private Tuple companyIds;

//    private Tuple holderChains;

    /**
     * 外部扩展id
     */
    private Tuple extendChains;

    /**
     * 为true表示该节点发送过，只需要传递就ok
     * 0:未处理过，1：已经发送消息
     */
    private IntWritable endFlag;

    public boolean isSendMsg() {
        return endFlag.get() == 0;
    }

    public static HolderRelationGroupVertexValue of(Text companyName/*, List<String> companyIds*/
            , List<String> extendChains) {
        HolderRelationGroupVertexValue hh = new HolderRelationGroupVertexValue();

        hh.setCompanyName(companyName);
//        if (companyIds != null && companyIds.size() > 0) {
//            //hh.companyIds = new Tuple();
//            for (String id : companyIds) {
//                Text text = new Text(id);
//                //hh.companyIds.append(text);
//            }
//        }



        if (hh.endFlag == null) {
            hh.endFlag = new IntWritable(0);
        }

        //初始化关系
        if (extendChains != null && extendChains.size() > 0) {
            hh.extendChains = new Tuple();
            Tuple tp2 = new Tuple();
            for (String cc : extendChains) {
                tp2.append(new Text(cc));
            }
            hh.extendChains.append(tp2);
        }
        return hh;
    }

    @Override
    public void write(DataOutput out) throws IOException {
        companyName.write(out);

        //companyIds.write(out);

        extendChains.write(out);
        endFlag.write(out);
    }

    @Override
    public void readFields(DataInput in) throws IOException {

        companyName = new Text();

        //companyIds = new Tuple();

        extendChains = new Tuple();
        endFlag = new IntWritable();


        companyName.readFields(in);

        //companyIds.readFields(in);

        extendChains.readFields(in);
        endFlag.readFields(in);
    }


    public Text getCompanyName() {
        return companyName;
    }

    public void setCompanyName(Text companyName) {
        this.companyName = companyName;
    }

/*    public Tuple getCompanyIds() {
        return companyIds;
    }*/
    public Tuple getCompanyIds() {
        if (extendChains == null) {
            return new Tuple();
        }
        List<String> collect = extendChains.getAll().stream()
                .filter(Objects::nonNull).flatMap(xx->{
                   return  ((Tuple)xx).getAll().stream().filter(Objects::nonNull).map(e -> ((Text) e).toString());
                })
                .distinct().collect(Collectors.toList());
        Tuple res = list2Tuple2(collect);

        return res;
    }


//    public void setCompanyIds(Tuple companyIds) {
//        this.companyIds = companyIds;
//    }

//    public Tuple getHolderChains() {
//        return holderChains;
//    }
//
//    public void setHolderChains(Tuple holderChains) {
//        this.holderChains = holderChains;
//    }

    public IntWritable getEndFlag() {
        return endFlag;
    }

    public void setEndFlag() {
        endFlag = new IntWritable(1);
    }

    public Tuple getExtendChains() {
        return extendChains;
    }

    public void setExtendChains(Tuple extendChains) {
        this.extendChains = extendChains;
    }

    public void setEndFlag(IntWritable endFlag) {
        this.endFlag = endFlag;
    }
}
