package com.winhc.max.compute.graph.job.holder.entity;

import com.aliyun.odps.graph.Edge;
import com.aliyun.odps.io.Text;

import java.util.*;

import static com.winhc.max.compute.graph.job.holder.HolderRelationGroupVertex.tuple2List;

/**
 * @author π
 * @Description:中转信息
 * @date 2024/5/29 17:00
 */
public class VertexCalcInfo {


    /**
     * 股权扩展集合
     */
    private List<Set<String>> extendChains = new ArrayList<>();

    /**
     * 当前企业id
     */
    private String currentVertexId;

    /**
     * 涉及企业id
     */
    //private HashSet<String> companyIds = new HashSet<>();


    public static VertexCalcInfo getVertexCalcInfo(String currentVertexId, HolderRelationGroupVertexValue currentVertexValue, List<Edge<Text, HolderRelationGroupEdge>> edges) {
        VertexCalcInfo vc = new VertexCalcInfo();

        if (currentVertexId != null) {
            vc.currentVertexId = currentVertexId;
            //vc.companyIds.add(currentVertexId);
        }
        if (edges == null || edges.isEmpty()) {
            return vc;
        }



        //扩展链路
        Set<String> set = new HashSet<>();
        edges.forEach(edge -> {
            set.add(edge.getDestVertexId().toString());
        });

        List<Set<String>> current_chanis = tuple2List(currentVertexValue.getExtendChains());
        if (current_chanis.isEmpty()) {
            vc.extendChains.add(set);
        } else {
            //替换
            vc.extendChains = current_chanis;
            vc.extendChains.get(0).addAll(set);
        }
        //vc.companyIds.addAll(set);
        return vc;
    }



   /* public HashSet<String> getCompanyIds() {
        return companyIds;
    }*/

    /**
     * 关联id提取
     * @return
     */
    public HashSet<String> getCompanyIds() {
        HashSet<String> resSet = new HashSet<>();
        if(currentVertexId != null) {
            resSet.add(currentVertexId);
        }
        if(extendChains != null) {
            extendChains.forEach(resSet::addAll);
        }
        return resSet;
    }

//    public void setCompanyIds(HashSet<String> companyIds) {
//        this.companyIds = companyIds;
//    }


    public String getCurrentVertexId() {
        return currentVertexId;
    }

    public void setCurrentVertexId(String currentVertexId) {
        this.currentVertexId = currentVertexId;
    }


    public List<Set<String>> getExtendChains() {
        return extendChains;
    }

    public void setExtendChains(List<Set<String>> extendChains) {
        this.extendChains = extendChains;
    }
}

