package com.winhc.max.compute.graph.util;

import com.aliyun.odps.conf.Configuration;
import com.aliyun.odps.data.TableInfo;
import com.aliyun.odps.graph.GraphLoader;
import com.aliyun.odps.graph.MutationContext;
import com.aliyun.odps.io.LongWritable;
import com.aliyun.odps.io.WritableRecord;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2023/5/5 16:08
 */
public abstract class GraphLoaderTestData extends GraphLoader {
    private Boolean loadTestData;

    @Override
    public void setup(Configuration conf, int workerId, TableInfo tableInfo, MutationContext context) throws IOException {
        loadTestData = true;
    }

    @Override
    public void load(LongWritable recordNum, WritableRecord record, MutationContext context) throws IOException {
        if (loadTestData) {
            loadTestData(context);
            loadTestData = false;
        }
    }


    /**
     * 添加测试数据
     *
     * @param context
     */
    public abstract void loadTestData(MutationContext context);
}
